/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis_ambassador/getambassador.io/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// KubernetesEndpointResolverLister helps list KubernetesEndpointResolvers.
type KubernetesEndpointResolverLister interface {
	// List lists all KubernetesEndpointResolvers in the indexer.
	List(selector labels.Selector) (ret []*v1.KubernetesEndpointResolver, err error)
	// KubernetesEndpointResolvers returns an object that can list and get KubernetesEndpointResolvers.
	KubernetesEndpointResolvers(namespace string) KubernetesEndpointResolverNamespaceLister
	KubernetesEndpointResolverListerExpansion
}

// kubernetesEndpointResolverLister implements the KubernetesEndpointResolverLister interface.
type kubernetesEndpointResolverLister struct {
	indexer cache.Indexer
}

// NewKubernetesEndpointResolverLister returns a new KubernetesEndpointResolverLister.
func NewKubernetesEndpointResolverLister(indexer cache.Indexer) KubernetesEndpointResolverLister {
	return &kubernetesEndpointResolverLister{indexer: indexer}
}

// List lists all KubernetesEndpointResolvers in the indexer.
func (s *kubernetesEndpointResolverLister) List(selector labels.Selector) (ret []*v1.KubernetesEndpointResolver, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KubernetesEndpointResolver))
	})
	return ret, err
}

// KubernetesEndpointResolvers returns an object that can list and get KubernetesEndpointResolvers.
func (s *kubernetesEndpointResolverLister) KubernetesEndpointResolvers(namespace string) KubernetesEndpointResolverNamespaceLister {
	return kubernetesEndpointResolverNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// KubernetesEndpointResolverNamespaceLister helps list and get KubernetesEndpointResolvers.
type KubernetesEndpointResolverNamespaceLister interface {
	// List lists all KubernetesEndpointResolvers in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.KubernetesEndpointResolver, err error)
	// Get retrieves the KubernetesEndpointResolver from the indexer for a given namespace and name.
	Get(name string) (*v1.KubernetesEndpointResolver, error)
	KubernetesEndpointResolverNamespaceListerExpansion
}

// kubernetesEndpointResolverNamespaceLister implements the KubernetesEndpointResolverNamespaceLister
// interface.
type kubernetesEndpointResolverNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all KubernetesEndpointResolvers in the indexer for a given namespace.
func (s kubernetesEndpointResolverNamespaceLister) List(selector labels.Selector) (ret []*v1.KubernetesEndpointResolver, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KubernetesEndpointResolver))
	})
	return ret, err
}

// Get retrieves the KubernetesEndpointResolver from the indexer for a given namespace and name.
func (s kubernetesEndpointResolverNamespaceLister) Get(name string) (*v1.KubernetesEndpointResolver, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("kubernetesendpointresolver"), name)
	}
	return obj.(*v1.KubernetesEndpointResolver), nil
}
